"use strict";

require("core-js/modules/es.array.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useLoaderApi = useLoaderApi;

function _react() {
  const data = require("react");

  _react = function () {
    return data;
  };

  return data;
}

function useLoaderApi() {
  const {
    current: loaders
  } = (0, _react().useRef)(new Set());
  const [isLoading, setIsLoading] = (0, _react().useState)(false);
  const reevaluate = (0, _react().useCallback)(() => {
    // setState hook does not trigger re-render
    // unless value differs
    setIsLoading(loaders.size > 0);
  }, [loaders]);
  const api = (0, _react().useMemo)(() => ({
    isActive: id => loaders.has(id),
    update: (id, value) => {
      const res = value ? !!loaders.add(id) : loaders.delete(id);
      reevaluate();
      return res;
    },
    remove: id => {
      const res = loaders.delete(id);
      reevaluate();
      return res;
    }
  }), [loaders, reevaluate]);
  return [api, isLoading];
}

//# sourceMappingURL=ui/global-loader/use-loader-api.js.map